Bug 171569 - Randon hang during rpm key import
Randon hang during rpm key import
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: rpm (Show other bugs)
4
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Paul Nasrat
Mike McLean
: Security
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2005-10-23 08:31 EDT by Graham Leggett
Modified: 2007-11-30 17:11 EST (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-10-25 11:35:06 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Graham Leggett 2005-10-23 08:31:57 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.7.8) Gecko/20050524 Fedora/1.0.4-4 Firefox/1.0.4

Description of problem:
While making an attempt to upgrade an FC3 system to FC4 using the FC4 DVD, for reasons unknown the rpm keys are not installed, and so up2date breaks making the false claim that packages are unsigned (where in reality, the key is not found).

An attempt to fix this situation by importing the relevant key hangs for no apparent reason like so:

[root@phoebe rpm-gpg]# rpm --install ./RPM-GPG-KEY-fedora-extras
^C
[root@phoebe rpm-gpg]#

An strace of the request ends as follows:

open("/selinux/context", O_RDWR|O_LARGEFILE) = 5
write(5, "root:object_r:user_home_t\0", 26) = 26
close(5)                                = 0
open("/selinux/context", O_RDWR|O_LARGEFILE) = 5
write(5, "root:object_r:httpd_user_content"..., 35) = 35
close(5)                                = 0
open("/selinux/context", O_RDWR|O_LARGEFILE) = 5
write(5, "root:object_r:texrel_shlib_t\0", 29) = 29
close(5)                                = 0
brk(0x8686000)                          = 0x8686000
close(3)                                = 0
munmap(0xb7feb000, 4096)                = 0
close(4)                                = 0
munmap(0xb7fea000, 4096)                = 0
open("RPM-GPG-KEY-fedora-extras", O_RDONLY|O_LARGEFILE) = 3
fcntl64(3, F_SETFD, FD_CLOEXEC)         = 0
poll([{fd=3, events=POLLIN, revents=POLLIN}], 1, 1000) = 1
read(3, "-----BEGIN PGP PUBLIC KEY BLOCK-"..., 96) = 96
close(3)                                = 0
open("RPM-GPG-KEY-fedora-extras", O_RDONLY|O_LARGEFILE) = 3
fcntl64(3, F_SETFD, FD_CLOEXEC)         = 0
mmap2(NULL, 8192, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0) = 0xb7fea000
poll([{fd=3, events=POLLIN, revents=POLLIN}], 1, 1000) = 1
read(3, "-----BEGIN PGP PUBLIC KEY BLOCK-"..., 8192) = 2043
poll([{fd=3, events=POLLIN, revents=POLLIN}], 1, 1000) = 1
read(3, "", 6149)                       = 0
poll([{fd=3, events=POLLIN, revents=POLLIN}], 1, 1000) = 1
read(3, "", 8192)                       = 0
open("/usr/share/locale/locale.alias", O_RDONLY) = 4
fstat64(4, {st_mode=S_IFREG|0644, st_size=2528, ...}) = 0
mmap2(NULL, 4096, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0) = 0xb7fe3000
read(4, "# Locale name alias data base.\n#"..., 4096) = 2528
read(4, "", 4096)                       = 0
close(4)                                = 0
munmap(0xb7fe3000, 4096)                = 0
open("/usr/share/locale/en_ZA.UTF-8/LC_MESSAGES/rpm.mo", O_RDONLY) = -1 ENOENT (No such file or directory)
open("/usr/share/locale/en_ZA.utf8/LC_MESSAGES/rpm.mo", O_RDONLY) = -1 ENOENT (No such file or directory)
open("/usr/share/locale/en_ZA/LC_MESSAGES/rpm.mo", O_RDONLY) = -1 ENOENT (No such file or directory)
open("/usr/share/locale/en.UTF-8/LC_MESSAGES/rpm.mo", O_RDONLY) = -1 ENOENT (No such file or directory)
open("/usr/share/locale/en.utf8/LC_MESSAGES/rpm.mo", O_RDONLY) = -1 ENOENT (No such file or directory)
open("/usr/share/locale/en/LC_MESSAGES/rpm.mo", O_RDONLY) = -1 ENOENT (No such file or directory)
close(3)                                = 0
munmap(0xb7fea000, 8192)                = 0
dup(0)                                  = 3
poll(
^^^^ Hangs here until ^C.

The inability to install the correct keys has DoS'ed up2date, effective rendering all attempts to apply security updates useless.


Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
xxx

Additional info:
Comment 1 Graham Leggett 2005-10-23 09:25:19 EDT
Doh.

It's --import for keys and not --install.

Still cannot see the reason for the hang though, an error message should be
thrown to say that the file is not an RPM.
Comment 2 Paul Nasrat 2005-10-25 11:35:06 EDT
RPM assumes a file is a manifest if it's not a package.  As you can install keys
and yum will do this for you in default setup, closinng.

Note You need to log in before you can comment on or make changes to this bug.